/**
 * findAndReplaceDOMText v 0.4.6
 * @author James Padolsey http://james.padolsey.com
 * @license http://unlicense.org/UNLICENSE
 *
 * Matches the text of a DOM node against a regular expression
 * and replaces each match (or node-separated portions of the match)
 * in the specified element.
 */
!function(e,t){"object"==typeof module&&module.exports?module.exports=t():"function"==typeof define&&define.amd?define(t):e.findAndReplaceDOMText=t()}(this,(function(){var e="retain",t="first",n=document,i={}.hasOwnProperty;function o(){return s.apply(null,arguments)||r.apply(null,arguments)}function s(e,t,n,i,s){if(t&&!t.nodeType&&arguments.length<=2)return!1;var a,d="function"==typeof n;d&&(a=n,n=function(e,t){return a(e.text,t.startIndex)});var c=r(t,{find:e,wrap:d?null:n,replace:d?n:"$"+(i||"&"),prepMatch:function(e,t){if(!e[0])throw"findAndReplaceDOMText cannot handle zero-length matches";if(i>0){var n=e[i];e.index+=e[0].indexOf(n),e[0]=n}return e.endIndex=e.index+e[0].length,e.startIndex=e.index,e.index=t,e},filterElements:s});return o.revert=function(){return c.revert()},!0}function r(e,t){return new a(e,t)}function a(t,n){var s=n.preset&&o.PRESETS[n.preset];if(n.portionMode=n.portionMode||e,s)for(var r in s)i.call(s,r)&&!i.call(n,r)&&(n[r]=s[r]);this.node=t,this.options=n,this.prepMatch=n.prepMatch||this.prepMatch,this.reverts=[],this.matches=this.search(),this.matches.length&&this.processMatches()}return o.NON_PROSE_ELEMENTS={br:1,hr:1,script:1,style:1,img:1,video:1,audio:1,canvas:1,svg:1,map:1,object:1,input:1,textarea:1,select:1,option:1,optgroup:1,button:1},o.NON_CONTIGUOUS_PROSE_ELEMENTS={address:1,article:1,aside:1,blockquote:1,dd:1,div:1,dl:1,fieldset:1,figcaption:1,figure:1,footer:1,form:1,h1:1,h2:1,h3:1,h4:1,h5:1,h6:1,header:1,hgroup:1,hr:1,main:1,nav:1,noscript:1,ol:1,output:1,p:1,pre:1,section:1,ul:1,br:1,li:1,summary:1,dt:1,details:1,rp:1,rt:1,rtc:1,script:1,style:1,img:1,video:1,audio:1,canvas:1,svg:1,map:1,object:1,input:1,textarea:1,select:1,option:1,optgroup:1,button:1,table:1,tbody:1,thead:1,th:1,tr:1,td:1,caption:1,col:1,tfoot:1,colgroup:1},o.NON_INLINE_PROSE=function(e){return i.call(o.NON_CONTIGUOUS_PROSE_ELEMENTS,e.nodeName.toLowerCase())},o.PRESETS={prose:{forceContext:o.NON_INLINE_PROSE,filterElements:function(e){return!i.call(o.NON_PROSE_ELEMENTS,e.nodeName.toLowerCase())}}},o.Finder=a,a.prototype={search:function(){var e,t=0,n=0,i=this.options.find,o=this.getAggregateText(),s=[],r=this;return i="string"==typeof i?RegExp(String(i).replace(/([.*+?^=!:${}()|[\]\/\\])/g,"\\$1"),"g"):i,function o(a){for(var d=0,c=a.length;d<c;++d){var h=a[d];if("string"==typeof h){if(i.global)for(;e=i.exec(h);)s.push(r.prepMatch(e,t++,n));else(e=h.match(i))&&s.push(r.prepMatch(e,0,n));n+=h.length}else o(h)}}(o),s},prepMatch:function(e,t,n){if(!e[0])throw new Error("findAndReplaceDOMText cannot handle zero-length matches");return e.endIndex=n+e.index+e[0].length,e.startIndex=n+e.index,e.index=t,e},getAggregateText:function(){var e=this.options.filterElements,t=this.options.forceContext;return function n(i){if(i.nodeType===Node.TEXT_NODE)return[i.data];if(e&&!e(i))return[];var o=[""],s=0;if(i=i.firstChild)do{if(i.nodeType!==Node.TEXT_NODE){var r=n(i);t&&i.nodeType===Node.ELEMENT_NODE&&(!0===t||t(i))?(o[++s]=r,o[++s]=""):("string"==typeof r[0]&&(o[s]+=r.shift()),r.length&&(o[++s]=r,o[++s]=""))}else o[s]+=i.data}while(i=i.nextSibling);return o}(this.node)},processMatches:function(){var e,t,n,i=this.matches,o=this.node,s=this.options.filterElements,r=[],a=o,d=i.shift(),c=0,h=0,u=[o];e:for(;;){if(a.nodeType===Node.TEXT_NODE&&(!t&&a.length+c>=d.endIndex?t={node:a,index:h++,text:a.data.substring(d.startIndex-c,d.endIndex-c),indexInMatch:0===c?0:c-d.startIndex,indexInNode:d.startIndex-c,endIndexInNode:d.endIndex-c,isEnd:!0}:e&&r.push({node:a,index:h++,text:a.data,indexInMatch:c-d.startIndex,indexInNode:0}),!e&&a.length+c>d.startIndex&&(e={node:a,index:h++,indexInMatch:0,indexInNode:d.startIndex-c,endIndexInNode:d.endIndex-c,text:a.data.substring(d.startIndex-c,d.endIndex-c)}),c+=a.data.length),n=a.nodeType===Node.ELEMENT_NODE&&s&&!s(a),e&&t){if(a=this.replaceMatch(d,e,r,t),c-=t.node.data.length-t.endIndexInNode,e=null,t=null,r=[],h=0,!(d=i.shift()))break}else if(!n&&(a.firstChild||a.nextSibling)){a.firstChild?(u.push(a),a=a.firstChild):a=a.nextSibling;continue}for(;;){if(a.nextSibling){a=a.nextSibling;break}if((a=u.pop())===o)break e}}},revert:function(){for(var e=this.reverts.length;e--;)this.reverts[e]();this.reverts=[]},prepareReplacementString:function(e,n,i){var o=this.options.portionMode;return o===t&&n.indexInMatch>0?"":(e=e.replace(/\$(\d+|&|`|')/g,(function(e,t){var n;switch(t){case"&":n=i[0];break;case"`":n=i.input.substring(0,i.startIndex);break;case"'":n=i.input.substring(i.endIndex);break;default:n=i[+t]||""}return n})),o===t?e:n.isEnd?e.substring(n.indexInMatch):e.substring(n.indexInMatch,n.indexInMatch+n.text.length))},getPortionReplacementNode:function(e,t){var i=this.options.replace||"$&",o=this.options.wrap,s=this.options.wrapClass;if(o&&o.nodeType){var r=n.createElement("div");r.innerHTML=o.outerHTML||(new XMLSerializer).serializeToString(o),o=r.firstChild}if("function"==typeof i)return(i=i(e,t))&&i.nodeType?i:n.createTextNode(String(i));var a="string"==typeof o?n.createElement(o):o;return a&&s&&(a.className=s),(i=n.createTextNode(this.prepareReplacementString(i,e,t))).data&&a?(a.appendChild(i),a):i},replaceMatch:function(e,t,i,o){var s,r,a=t.node,d=o.node;if(a===d){var c=a;t.indexInNode>0&&(s=n.createTextNode(c.data.substring(0,t.indexInNode)),c.parentNode.insertBefore(s,c));var h=this.getPortionReplacementNode(o,e);return c.parentNode.insertBefore(h,c),o.endIndexInNode<c.length&&(r=n.createTextNode(c.data.substring(o.endIndexInNode)),c.parentNode.insertBefore(r,c)),c.parentNode.removeChild(c),this.reverts.push((function(){s===h.previousSibling&&s.parentNode.removeChild(s),r===h.nextSibling&&r.parentNode.removeChild(r),h.parentNode.replaceChild(c,h)})),h}s=n.createTextNode(a.data.substring(0,t.indexInNode)),r=n.createTextNode(d.data.substring(o.endIndexInNode));for(var u=this.getPortionReplacementNode(t,e),l=[],p=0,f=i.length;p<f;++p){var g=i[p],v=this.getPortionReplacementNode(g,e);g.node.parentNode.replaceChild(v,g.node),this.reverts.push(function(e,t){return function(){t.parentNode.replaceChild(e.node,t)}}(g,v)),l.push(v)}var m=this.getPortionReplacementNode(o,e);return a.parentNode.insertBefore(s,a),a.parentNode.insertBefore(u,a),a.parentNode.removeChild(a),d.parentNode.insertBefore(m,d),d.parentNode.insertBefore(r,d),d.parentNode.removeChild(d),this.reverts.push((function(){s.parentNode.removeChild(s),u.parentNode.replaceChild(a,u),r.parentNode.removeChild(r),m.parentNode.replaceChild(d,m)})),m}},o}));const findInNw={options:{},caseSensitive:!1,initialized:!1,lastSearched:"",total:0,currentToken:0,dataAttribute:"data-find-in-nw-position",observer:null,observerActive:!1,resetState:function(){this.lastSearched="",this.total=0,this.currentToken=0},create:{css:".find-in-nw-search-box{position:fixed;top:10px;right:10px;display:none;width:300px;background:#f1f1f1;border:1px solid #c1c1c1;border-radius:7px;margin:0px;padding:0px;box-shadow:1px 3px 9px rgba(0,0,0,.6)}.find-in-nw-search-box-visible{display:flex}.find-in-nw-input{flex-grow:1;width:100%;background:transparent;border:0px;margin:0px;padding:0px 0px 0px 3px;font-size:16px}.find-in-nw-case-sensitive,.find-in-nw-previous,.find-in-nw-next,.find-in-nw-close{width:32px;background:transparent;border:0px;margin:0px 5px 0px 0px;padding:0px;font-size:32px;opacity:.5}.find-in-nw-case-sensitive:hover,.find-in-nw-previous:hover,.find-in-nw-next:hover,.find-in-nw-close:hover{opacity:1}.find-in-nw-search-box,.find-in-nw-input,.find-in-nw-count,.find-in-nw-case-sensitive,.find-in-nw-previous,.find-in-nw-next,.find-in-nw-close{height:32px;color:#000;font-family:sans-serif;line-height:32px;vertical-align:top}.find-in-nw-input:focus,.find-in-nw-case-sensitive:focus,.find-in-nw-previous:focus,.find-in-nw-next:focus,.find-in-nw-close:focus{opacity:1;outline:none}.find-in-nw-case-sensitive{font-size:20px}.find-in-nw-case-sensitive:focus,.find-in-nw-case-sensitive:hover{opacity:.5}.find-in-nw-previous,.find-in-nw-next{font-size:30px;transform:scale(1.5, 0.7)}.find-in-nw-button-active,.find-in-nw-button-active:focus,.find-in-nw-button-active:hover{opacity:1}.find-in-nw-count{margin-right:8px}.find-in-nw-token{background-color:#ff0}.find-in-nw-current-token{background:#38d878;color:#fff}",style:function(){const e=document.createElement("style");return e.setAttribute("id","find-in-nw-style"),e.innerText=this.css,e},container:function(){const e=document.createElement("div");return e.setAttribute("id","find-in-nw-search-box"),e.setAttribute("class","find-in-nw-search-box"),e},input:function(){const e=document.createElement("input");return e.setAttribute("id","find-in-nw-input"),e.setAttribute("class","find-in-nw-input"),e.setAttribute("placeholder","Find"),e},element:function(e,t,n){const i=document.createElement(e);return i.setAttribute("id","find-in-nw-"+t),i.setAttribute("class","find-in-nw-"+t),i.innerHTML=n+"",i},composeSearchBox:function(){const e=this.container();return e.appendChild(this.input()),e.appendChild(this.element("span","current",0)),e.appendChild(this.element("span","of","/")),e.appendChild(this.element("span","count",0)),e.appendChild(this.element("button","case-sensitive","Aa")),e.appendChild(this.element("button","previous","&and;")),e.appendChild(this.element("button","next","&or;")),e.appendChild(this.element("button","close","&times;")),e}},keyDownPressed:function(){document.getElementById("find-in-nw-input").addEventListener("keydown",function(e){"Enter"===e.key&&this.highlightNext()}.bind(this))},inputChanged:function(){document.getElementById("find-in-nw-input").addEventListener("input",function(e){e.preventDefault();const t=e.target.value;t&&t!==this.lastSearched?this.search(t):t||this.clearTokens()}.bind(this))},previousButtonClicked:function(){document.getElementById("find-in-nw-previous").addEventListener("click",function(e){e.preventDefault(),this.highlightPrevious()}.bind(this))},nextButtonClicked:function(){document.getElementById("find-in-nw-next").addEventListener("click",function(e){e.preventDefault(),this.highlightNext()}.bind(this))},closeButtonClicked:function(){document.getElementById("find-in-nw-close").addEventListener("click",function(e){e.preventDefault(),this.stopObservingDomChanges("closeButtonClicked"),this.hideSearchBox()}.bind(this))},caseSensitiveButtonClicked:function(){const e=document.getElementById("find-in-nw-case-sensitive"),t="find-in-nw-button-active",n=document.getElementById("find-in-nw-input");e.addEventListener("click",function(i){i.preventDefault(),this.stopObservingDomChanges("caseSensitiveButtonClicked"),this.caseSensitive?(this.caseSensitive=!1,e.classList.remove(t)):(this.caseSensitive=!0,e.classList.add(t)),this.search(n.value)}.bind(this))},eventBinding:function(){this.keyDownPressed(),this.inputChanged(),this.previousButtonClicked(),this.nextButtonClicked(),this.closeButtonClicked(),this.caseSensitiveButtonClicked()},keyBindings:function(){document.onkeydown=function(e){return e.ctrlKey&&70===e.keyCode?(e.preventDefault(),this.showSearchBox(),!1):27===e.keyCode?(e.preventDefault(),this.hideSearchBox(),!1):void 0}.bind(this)},observeDomChanges:function(e){if(this.observerActive)return;this.observerActive=!0;this.options&&this.options.verbose;const t=this.options&&this.options.classesToIgnore||[],n=this.options&&this.options.idsToIgnore||[];MutationObserver=window.MutationObserver||window.WebKitMutationObserver,this.observer=new MutationObserver(function(e,i){if(this.initialized){const i=e.filter((function(e){const i=!t.some((function(t){return e.target.classList.contains(t)})),o=!n.some((function(t){return e.target.id===t}));return i&&o}));i.length&&(this.options.verbose&&this.log({mutations:i}),this.search(this.lastSearched))}}.bind(this)),this.observer.observe(document,{subtree:!0,attributes:!0,characterData:!0})},stopObservingDomChanges:function(e){this.observerActive&&(this.observerActive=!1,this.observer&&this.observer.disconnect&&this.observer.disconnect())},initCurrentToken:function(){this.stopObservingDomChanges("initCurrentToken");const e=function(e){const t=e.getBoundingClientRect();return t.top>=0&&t.left>=0&&t.bottom<=(window.innerHeight||document.documentElement.clientHeight)&&t.right<=(window.innerWidth||document.documentElement.clientWidth)},t=document.getElementsByClassName("find-in-nw-token");for(const n of t)if(e(n)){this.currentToken=parseInt(n.getAttribute(this.dataAttribute))||0;break}},highlightPrevious:function(){this.stopObservingDomChanges("highlightPrevious"),this.currentToken=this.currentToken-1,this.currentToken<0&&(this.currentToken=this.total-1),this.updateCount(),this.highlightCurrentToken()},highlightNext:function(){this.stopObservingDomChanges("highlightNext"),this.currentToken=this.currentToken+1,this.currentToken>this.total-1&&(this.currentToken=0),this.updateCount(),this.highlightCurrentToken()},showSearchBox:function(){this.stopObservingDomChanges("showSearchBox");const e=document.getElementById("find-in-nw-search-box"),t=document.getElementById("find-in-nw-input");e.classList.add("find-in-nw-search-box-visible");const n=window.getSelection().toString();n&&n.indexOf("\n")<0&&(t.value=n),t.value&&this.search(t.value),t.focus()},hideSearchBox:function(){this.stopObservingDomChanges("hideSearchBox");document.getElementById("find-in-nw-search-box").classList.remove("find-in-nw-search-box-visible"),document.body.focus(),this.clearTokens()},getElementsToSearch:function(){const e=[];for(let t=0;t<document.body.children.length;t++){const n=document.body.children[t],i="style"===n.tagName.toLowerCase(),o="script"===n.tagName.toLowerCase(),s=n.id&&"find-in-nw-search-box"===n.id;i||o||s||e.push(n)}return e},setDataPositionAttribute:function(){this.stopObservingDomChanges("setDataPositionAttribute");let e=0,t=this.lastSearched.length,n=t;const i=document.getElementsByClassName("find-in-nw-token");[...i].forEach(function(i){let o=i.innerText.length;i.setAttribute(this.dataAttribute,e),o===t?(e+=1,n=t):(n-=o,n<1&&(e+=1,n=t))}.bind(this)),i||(e=0),this.total=e},highlightCurrentToken:function(){const e="find-in-nw-current-token";let t=document.getElementsByClassName(e),n=document.querySelectorAll(".find-in-nw-token["+this.dataAttribute+'="'+this.currentToken+'"]');if(1===t.length){if(t[0].attributes["data-find-in-nw-position"].value==this.currentToken)return}this.stopObservingDomChanges("highlightCurrentToken"),t&&t.length&&(t=[...t],t.forEach((function(t){t.classList.remove(e)}))),n&&n.length&&(n=[...n],n.forEach((function(t){t.classList.add(e)})),n[0].scrollIntoView({behavior:"auto",block:"center",inline:"center"})),this.observeDomChanges("highlightCurrentToken")},updateCount:function(){this.stopObservingDomChanges("updateCount");const e=document.getElementById("find-in-nw-current"),t=document.getElementById("find-in-nw-count");let n=0;0!==this.total&&(n=this.currentToken+1),e.innerHTML=n.toLocaleString(),t.innerHTML=this.total.toLocaleString()},clearTokens:function(){this.stopObservingDomChanges("clearTokens");const e=document.getElementsByClassName("find-in-nw-token");let t=[];for(let n=0;n<e.length;n++)t.push(e[n].parentNode);for(t=Array.from(new Set(t));e.length;)e[0].replaceWith(...e[0].childNodes);t.forEach((function(e){e.normalize()})),this.resetState(),this.updateCount()},search:function(e){this.stopObservingDomChanges("search"),this.clearTokens();const t=this.getElementsToSearch(),n=this.options;let i="i";this.caseSensitive&&(i=""),e&&t.forEach(function(t){window.findAndReplaceDOMText(t,{find:RegExp(e,"g"+i),wrap:"mark",wrapClass:"find-in-nw-token",filterElements:function(e){return e.offsetWidth>0&&e.offsetHeight>0},...n})}.bind(this)),this.lastSearched=e,this.setDataPositionAttribute(),this.initCurrentToken(),this.updateCount(),this.highlightCurrentToken(),this.observeDomChanges("search")},log:function(e,t){const n=t||this.options&&this.options.verbose;e&&n&&console.log("find-in-nw:",e)},defaultBoolean:function(e,t,n){if(n=!!n,Object(e).hasOwnProperty(t)){if("boolean"==typeof e[t])return void(this.options[t]=e[t]);this.log('Optional "'+t+'" setting must be a boolean. Defaulting to '+n,!0)}this.options[t]=n},validateArrayOfStrings:function(e,t){if(Object(e).hasOwnProperty(t)){if(Array.isArray(e[t])){if(!e[t].some((function(e){return"string"!=typeof e})).length)return void(this.options[t]=e[t])}this.log('Optional "'+t+'" setting must be an array of strings.',!0)}this.options[t]=[]},validateOptions:function(e){"object"!=typeof e||Array.isArray(e)?this.log("Options must be an object or undefined"):(this.defaultBoolean(e,"verbose",!0),this.validateArrayOfStrings(e,"classesToIgnore"),this.validateArrayOfStrings(e,"idsToIgnore"))},initialize:function(e){if(this.validateOptions(e),!this.initialized){const e=this.create.style(),t=this.create.composeSearchBox();document.body.append(t),document.body.append(e),this.keyBindings(),this.eventBinding(),this.initialized=!0}}};
